<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/gimli-0.26.2/src/lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../gimli/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../gimli/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../gimli/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
</pre><pre class="rust"><code><span class="doccomment">//! `gimli` is a library for reading and writing the</span>
<span class="doccomment">//! [DWARF debugging format](https://dwarfstd.org/).</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! See the [read](./read/index.html) and [write](./write/index.html) modules</span>
<span class="doccomment">//! for examples and API documentation.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## Cargo Features</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Cargo features that can be enabled with `gimli`:</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! * `std`: Enabled by default. Use the `std` library. Disabling this feature</span>
<span class="doccomment">//! allows using `gimli` in embedded environments that do not have access to</span>
<span class="doccomment">//! `std`. Note that even when `std` is disabled, `gimli` still requires an</span>
<span class="doccomment">//! implementation of the `alloc` crate.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! * `read`: Enabled by default. Enables the `read` module. Use of `std` is</span>
<span class="doccomment">//! optional.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! * `write`: Enabled by default. Enables the `write` module. Always uses</span>
<span class="doccomment">//! the `std` library.</span>
<span class="attribute">#![<span class="ident">deny</span>(<span class="ident">missing_docs</span>)]</span>
<span class="attribute">#![<span class="ident">deny</span>(<span class="ident">missing_debug_implementations</span>)]</span>
<span class="comment">// Selectively enable rust 2018 warnings</span>
<span class="attribute">#![<span class="ident">warn</span>(<span class="ident">bare_trait_objects</span>)]</span>
<span class="attribute">#![<span class="ident">warn</span>(<span class="ident">unused_extern_crates</span>)]</span>
<span class="attribute">#![<span class="ident">warn</span>(<span class="ident">ellipsis_inclusive_range_patterns</span>)]</span>
<span class="comment">//#![warn(elided_lifetimes_in_paths)]</span>
<span class="attribute">#![<span class="ident">warn</span>(<span class="ident">explicit_outlives_requirements</span>)]</span>
<span class="comment">// Allow clippy warnings when we aren&#39;t building with clippy.</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">unknown_lints</span>)]</span>
<span class="comment">// False positives with `fallible_iterator`.</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">clippy::should_implement_trait</span>)]</span>
<span class="comment">// Many false positives involving `continue`.</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">clippy::never_loop</span>)]</span>
<span class="comment">// False positives when block expressions are used inside an assertion.</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">clippy::panic_params</span>)]</span>
<span class="attribute">#![<span class="ident">no_std</span>]</span>

<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unused_imports</span>)]</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;read&quot;</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;write&quot;</span>))]</span>
<span class="attribute">#[<span class="ident">macro_use</span>]</span>
<span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">alloc</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;write&quot;</span>))]</span>
<span class="attribute">#[<span class="ident">macro_use</span>]</span>
<span class="kw">extern</span> <span class="kw">crate</span> <span class="ident">std</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;stable_deref_trait&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">stable_deref_trait</span>::{<span class="ident">CloneStableDeref</span>, <span class="ident">StableDeref</span>};

<span class="kw">mod</span> <span class="ident">common</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::common</span>::<span class="kw-2">*</span>;

<span class="kw">mod</span> <span class="ident">arch</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::arch</span>::<span class="kw-2">*</span>;

<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">constants</span>;
<span class="comment">// For backwards compat.</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::constants</span>::<span class="kw-2">*</span>;

<span class="kw">mod</span> <span class="ident">endianity</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::endianity</span>::{<span class="ident">BigEndian</span>, <span class="ident">Endianity</span>, <span class="ident">LittleEndian</span>, <span class="ident">NativeEndian</span>, <span class="ident">RunTimeEndian</span>};

<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">leb128</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;read-core&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">read</span>;
<span class="comment">// For backwards compat.</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;read-core&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::read</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;write&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">write</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">test_util</span>;
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="gimli" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>